options pagesize=59 linesize=80 nocenter;
data rni;
infile 'c:/datasets/last_interview.dat' lrecl=67 missover DSD DLM=' ';
input
   caseid     /* R0000100   */
   rni80      /* R0406310   */
   rni81      /* R0618810   */
   rni82      /* R0898510   */
   rni83      /* R1144710   */
   rni84      /* R1519910   */
   rni85      /* R1890300   */
   rni86      /* R2257400   */
   rni87      /* R2444600   */
   rni88      /* R2870100   */
   rni89      /* R3073900   */
   rni90      /* R3400500   */
   rni91      /* R3655900   */
   rni92      /* R4006400   */
   rni93      /* R4417500   */  
   rni94      /* R5080500   */  
   rni96      /* R5165800   */  
   rni98      /* R6478500   */  
   rni00      /* R7006300   */  
   rni02      /* R7703500   */  
   rni04      /* R8495900   */  
  ;
/* comment out array recoding missing values;
array chrrlst 
  caseid -- rni04
  ;
do over chrrlst;
  if chrrlst = -5 then chrrlst = .A;
  if chrrlst = -4 then chrrlst = .B;
  if chrrlst = -3 then chrrlst = .C;
  if chrrlst = -2 then chrrlst = .D;
  if chrrlst = -1 then chrrlst = .E;
  end;
*/
label  caseid  = "ID# (1-12686) 79";
label  rni80   = "REASON FOR NONINT 80";
label  rni81   = "REASON FOR NONINT 81";
label  rni82   = "REASON FOR NONINT 82";
label  rni83   = "REASON FOR NONINT 83";
label  rni84   = "REASON FOR NONINT 84";
label  rni85   = "REASON FOR NONINT 85";
label  rni86   = "REASON FOR NONINT 86";
label  rni87   = "REASON FOR NONINT 87";
label  rni88   = "REASON FOR NONINT 88";
label  rni89   = "REASON FOR NONINT 89";
label  rni90   = "REASON FOR NONINT 90";
label  rni91   = "REASON FOR NONINT 91";
label  rni92   = "REASON FOR NONINT 92";
label  rni93   = "REASONS FOR NON-INT 93";
label  rni94   = "REASONS FOR NON-INT 94";
label  rni96   = "REASONS FOR NON-INT 96";
label  rni98   = "REASONS FOR NON-INT 1998";
label  rni00   = "REASONS FOR NON-INT 2000";
label  rni02   = "REASONS FOR NON-INT 2002";
label  rni04   = "REASONS FOR NON-INT 2004";
proc format;
value vx1f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT AND YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT AND YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
    ;
value vx2f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT AND YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT AND YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
    ;
value vx3f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
    ;
value vx4f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
    ;
value vx5f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
    ;
value vx6f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
    ;
value vx7f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
    ;
value vx8f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
    ;
value vx9f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
    ;
value vx10f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
    ;
value vx11f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
    ;
value vx12f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
  69='SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
    ;
value vx13f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
  69='SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
    ;
value vx14f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
  69='SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
    ;
value vx15f
  60='60: 60  PARENT REFUSAL/BREAKOFF'
  61='61: 61  YOUTH REFUSAL/BREAKOFF'
  62='62: 62  PARENT & YOUTH REFUSAL/BREAKOFF'
  63='63: 63  UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='64: 64  UNABLE TO LOCATE YOUTH'
  65='65: 65  DECEASED'
  66='66: 66  OTHER'
  67='67: 67  DO NOT REFIELD (VERY DIFFICULT CASE)'
  68='68: 68  MILITARY SAMPLE DROPPED'
  69='69: 69  SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='70: 70  SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
    ;
value vx16f
  60='60: PARENT REFUSAL/BREAKOFF'
  61='61: YOUTH REFUSAL/BREAKOFF'
  62='62: PARENT & YOUTH REFUSAL/BREAKOFF'
  63='63: UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='64: UNABLE TO LOCATE YOUTH'
  65='65: DECEASED'
  66='66: OTHER'
  67='67: DO NOT REFIELD (VERY DIFFICULT CASE)'
  68='68: MILITARY SAMPLE DROPPED'
  69='69: SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='70: SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
    ;
value vx17f
  60='60: 60  PARENT REFUSAL/BREAKOFF'
  61='61: 61  YOUTH REFUSAL/BREAKOFF'
  62='62: 62  PARENT & YOUTH REFUSAL/BREAKOFF'
  63='63: 63  UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='64: 64  UNABLE TO LOCATE YOUTH'
  65='65: 65  DECEASED'
  66='66: 66  OTHER'
  67='67: 67  DO NOT REFIELD (VERY DIFFICULT CASE)'
  68='68: 68  MILITARY SAMPLE DROPPED'
  69='69: 69  SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='70: 70  SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
    ;
value vx18f
  60='60: PARENT REFUSAL/BREAKOFF'
  61='61: YOUTH REFUSAL/BREAKOFF'
  62='62: PARENT & YOUTH REFUSAL/BREAKOFF'
  63='63: UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='64: UNABLE TO LOCATE YOUTH'
  65='65: DECEASED'
  66='66: OTHER'
  67='67: DO NOT REFIELD (VERY DIFFICULT CASE)'
  68='68: MILITARY SAMPLE DROPPED'
  69='69: SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='70: SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
  71='71: YOUTH REFUSAL - VERY DIFFICULT CASE'
    ;
value vx19f
  60='60: 60  PARENT REFUSAL/BREAKOFF'
  61='61: 61  YOUTH REFUSAL/BREAKOFF'
  62='62: 62  PARENT & YOUTH REFUSAL/BREAKOFF'
  63='63: 63  UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='64: 64  UNABLE TO LOCATE YOUTH'
  65='65: 65  DECEASED'
  66='66: 66  OTHER'
  67='67: 67  DO NOT REFIELD (VERY DIFFICULT CASE)'
  68='68: 68  MILITARY SAMPLE DROPPED'
  69='69: 69  SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='70: 70  SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
  71='71: 71  YOUTH REFUSAL - VERY DIFFICULT CASE'
  72='72: 72  NOT FIELDED IN CURRENT SURVEY YEAR - VERY DIFFICULT CASE'
    ;
value vx20f
  60='60: 60  PARENT REFUSAL/BREAKOFF'
  61='61: 61  YOUTH REFUSAL/BREAKOFF'
  62='62: 62  PARENT & YOUTH REFUSAL/BREAKOFF'
  63='63: 63  UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='64: 64  UNABLE TO LOCATE YOUTH'
  65='65: 65  DECEASED'
  66='66: 66  OTHER'
  67='67: 67  DO NOT REFIELD (VERY DIFFICULT CASE)'
  68='68: 68  MILITARY SAMPLE DROPPED'
  69='69: 69  SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='70: 70  SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
  71='71: 71  YOUTH REFUSAL - VERY DIFFICULT CASE'
  72='72: 72  NOT FIELDED IN CURRENT SURVEY YEAR - VERY DIFFICULT CASE'
  73='73: 73  NOT INTERVIEWED - INCARCERATED'
  74='74: 74  NOT INTERVIEWED - IN MILITARY'
    ;
/*
  format rni80 vx1f.;
  format rni81 vx2f.;
  format rni82 vx3f.;
  format rni83 vx4f.;
  format rni84 vx5f.;
  format rni85 vx6f.;
  format rni86 vx7f.;
  format rni87 vx8f.;
  format rni88 vx9f.;
  format rni89 vx10f.;
  format rni90 vx11f.;
  format rni91 vx12f.;
  format rni92 vx13f.;
  format rni93 vx14f.;
  format rni94 vx15f.;
  format rni96 vx16f.;
  format rni98 vx17f.;
  format rni00 vx18f.;
  format rni02 vx19f.;
  format rni04 vx20f.;
*/
/* *start* Crosswalk for Reference number & Question name
    R0000100    CASEID
    R0406310    *Created
    R0618810    *Created
    R0898510    *Created
    R1144710    *Created
    R1519910    *Created
    R1890300    *Created
    R2257400    *Created
    R2444600    *Created
    R2870100    *Created
    R3073900    *Created
    R3400500    *Created
    R3655900    *Created
    R4006400    *Created
    R4417500    RNI
    R5080500    RNI
    R5165800    RNI
    R6478500    RNI
    R7006300    RNI
    R7703500    RNI
    R8495900    RNI
      * *finish* */
proc means n mean min max;
proc sort; by caseid;
run;

* computes most recent interview year and number of years interviewed;
data compute1;
set rni;

* initialize rni for 1979 to -4 - there are no rnis for 1979;
rni79=-4;

* array rnis from 2004 to 1979;
array rni (i) rni04 rni02 rni00 rni98 rni96 rni94 rni93 rni92 rni91 rni90
              rni89 rni88 rni87 rni86 rni85 rni84 rni83 rni82 rni81 rni80 rni79;

*compute a year of interview;
intyr04=2004;
intyr02=2002;
intyr00=2000;
intyr98=1998;
intyr96=1996;
intyr94=1994;
intyr93=1993;
intyr92=1992;
intyr91=1991;
intyr90=1990;
intyr89=1989;
intyr88=1988;
intyr87=1987;
intyr86=1986;
intyr85=1985;
intyr84=1984;
intyr83=1983;
intyr82=1982;
intyr81=1981;
intyr80=1980;
intyr79=1979;

* array interview years from 2004 to 1979;
array intyr (i) intyr04 intyr02 intyr00 intyr98 intyr96 intyr94 intyr93 intyr92
                intyr91 intyr90 intyr89 intyr88 intyr87 intyr86 intyr85 intyr84
                intyr83 intyr82 intyr81 intyr80 intyr79;
              
* computes most recent interview year;
* computes number of years interviewed;
lintyear = -4;
yrs_int = 0;
do i = 1 to 21;
 if (rni = -4) then lintyear = intyr;
 if (lintyear > -4) then do;
  goto out1;
 end;
end; out1:


do i = 1 to 21;
 if (rni = -4) then yrs_int = yrs_int+1;
end;
run;


* create sample of every 200 cases;
data sample200;
set compute1;

if mod(_N_, 200) =0  then output sample200;

run;


data test1;
set sample200;

proc print; var caseid lintyear yrs_int rni04 rni02 rni00 rni98 rni96 rni94 rni93 rni92 rni91 rni90
              rni89 rni88 rni87 rni86 rni85 rni84 rni83 rni82 rni81 rni80 rni79;
 
run;
