options pagesize=59 linesize=120 nocenter;
data RawData;

%Macro AdjAFQT (InScore, Age, OutScore);

if (&InScore ^= .) then do;
	If (&Age = 14) then &OutScore = &InScore + (163.37 - 149.40);
	If (&Age = 15) then &OutScore = &InScore + (163.37 - 155.66);
	If (&Age = 16) then &OutScore = &InScore + (163.37 - 158.66);
	If (&Age = 17) then &OutScore = &InScore + (163.37 - 159.37);
	If (&Age = 18) then &OutScore = &InScore + (163.37 - 161.41);
	If (&Age = 19) then &OutScore = &InScore + (163.37 - 167.50);
	If (&Age = 20) then &OutScore = &InScore + (163.37 - 173.67);
	If (&Age = 21) then &OutScore = &InScore + (163.37 - 172.77);
	If (&Age = 22) then &OutScore = &InScore + (163.37 - 177.21);
end;

%Mend AdjAFQT;

/***********************************/
/*     Step 1:  Read in Variables  */
/***********************************/

infile 'C:\Documents and Settings\All Users\Desktop\ClusteringandWeighting\79wagedata.dat' lrecl=101;
input
 R0000100  5.
 R0000600  2.
 R0214700  2.
 R0214800  2.
 R0618011  2.
 R0618012  2.
 R0618013  2.
 R0618014  2.
 R0618200  2.
 R3127800  7.
 R3401300  2.
 R3401501  2.
 R3401700  2.
 R3523500  7.
 R3656700  2.
 R3656901  2.
 R3657100  2.
 R3728500  7.
 R4007200  2.
 R4007401  2.
 R4007600  2.
 R4416800  7.
 R4418300  2.
 R4418501  2.
 R4418700  2.
 R5079800  5.
 R5081300  2.
 R5081700  2.
 R5103900  2.
 R5166600  2.
 R5166901  2.
 R5167000  2.
 R6478000  5.
 R6479200  2.
 R6479600  2.
 R6479800  2.
 ;

label R0000100 = "ID# (1-12686) 79";
label R0000600 = "AGE OF R 79";
label R0214700 = "RACL/ETHNIC COHORT /SCRNR 79";
label R0214800 = "SEX OF R 79";
label R0618011 = "PROFILES ASVAB SEC 2-STD SCRNR 81";
label R0618012 = "PROFILES ASVAB SEC 3-STD SCRNR 81";
label R0618013 = "PROFILES ASVAB SEC 4-STD SCRNR 81";
label R0618014 = "PROFILES ASVAB SEC 5-STD SCRNR 81";
label R0618200 = "PROFILES AFQT PRCTILE SCORE-80 81";
label R3127800 = "HRP CURRENT/M-RCNT JOB 90";
label R3401300 = "MARITAL STATUS (COLLAPSED) 90";
label R3401501 = "HIGHEST GRADE COMPLTD (REV) 90";
label R3401700 = "AGE OF R @ INT DATE 90";
label R3523500 = "HRP CURRENT/M-RCNT JOB 91";
label R3656700 = "MARITAL STATUS (COLLAPSED) 91";
label R3656901 = "HIGHEST GRADE COMPLTD (REV) 91";
label R3657100 = "AGE OF R @ INT DATE 91";
label R3728500 = "HRP CURRENT/M-RCNT JOB 92";
label R4007200 = "MARITAL STATUS (COLLAPSED) 92";
label R4007401 = "HIGHEST GRADE COMPLTD (REV) 92";
label R4007600 = "AGE OF R @ INT DATE 92";
label R4416800 = "HRLY RATE OF PAY CPS JOB 93";
label R4418300 = "MARITAL STATUS (COLLAPSED) 93";
label R4418501 = "HIGHEST GRADE COMPLTD (REV) 93";
label R4418700 = "AGE AT INTERVIEW DATE 93";
label R5079800 = "HRLY RATE OF PAY CPS JOB 94";
label R5081300 = "MARITAL STATUS (COLLAPSED) 94";
label R5081700 = "AGE AT INTERVIEW DATE 94";
label R5103900 = "HIGHEST GRADE COMPLTD (REV) 94";
label R5166600 = "MARITAL STATUS (COLLAPSED) 96";
label R5166901 = "HIGHEST GRADE COMPLTD (REV) 96";
label R5167000 = "AGE AT INTERVIEW DATE 96";
label R6478000 = "HRLY RATE OF PAY JOB# 1 1998";
label R6479200 = "MARITAL STATUS (COLLAPSED) 1998";
label R6479600 = "HIGHEST GRADE COMPLTD (REV) 1998";
label R6479800 = "AGE AT INTERVIEW DATE 1998";

infile 'C:\Documents and Settings\All Users\Desktop\ClusteringandWeighting\79PSUs.dat' lrecl=10;
input
 R0000100  5.
 R0219145  3.
 R0219146  2.
 ;

label R0000100 = "ID# (1-12686) 79";
label R0219145 = "STRATUM # FOR PSU 79";
label R0219146 = "PRIMARY SAMPLNG UNIT PSU SCRAMBLED 79";

infile 'C:\Documents and Settings\All Users\Desktop\ClusteringandWeighting\79geovariables.dat' lrecl=29;
input
 R0000100  5.
 R0215100  2.
 R0215200  2.
 R0216400  2.
 R0219003  4.
 R0219010  3.
 R0219011  3.
 R0219103  5.
 R0219144  3.
 ;

label R0000100 = "ID# (1-12686) 79";
label R0215100 = "RS CURRENT RESIDENCE URBAN/RURAL 79";
label R0215200 = "RS CURRENT RESIDENCE IN SMSA 79";
label R0216400 = "REGION OF CURRENT RESIDENCE 79";
label R0219003 = "SMSA OF RESIDENCE 79";
label R0219010 = "PRCT POP BLACK-70 CCDB 77 CNTY 79";
label R0219011 = "PRCT POP HISPANIC-70 CCDB 72 CNTY 79";
label R0219103 = "MED FAM INC($)-69 CCDB 77 SMSA 79";
label R0219144 = "79 CONT UNEMP RATE LAB MARK CUR RES";

/*****************************************************************/
/*     Step 2:  Give Variables Simple Names and Eliminate Women. */
/*****************************************************************/

TRUE  = 1;
FALSE = 0;

ID = R0000100;  /* ID# (1-12686) 79 */
Age1979 = R0000600; /* AGE OF R 79 */
Group   = R0214700; /* RACL/ETHNIC COHORT /SCRNR 79 */
if (Group =  2)
	then Black = TRUE;
	else Black = FALSE;
if (Group =  1)
	then HISPANIC = TRUE;
	else HISPANIC = FALSE;

Gender  = R0214800; /* SEX OF R 79    1 MALE     2 FEMALE  */

/* Track just males */
if (Gender = 2) then delete;

/* Handle Adjusted AFQT Score calculation here. */
Sec2_Score = R0618011; /* PROFILES ASVAB SEC 2-STD SCRNR 81 */
Sec3_Score = R0618012; /* PROFILES ASVAB SEC 3-STD SCRNR 81 */
Sec4_Score = R0618013; /* PROFILES ASVAB SEC 4-STD SCRNR 81 */
Sec5_Score = R0618014; /* PROFILES ASVAB SEC 5-STD SCRNR 81 */
ASVAB_Score = R0618200; /* PROFILES AFQT PRCTILE SCORE-80 81 */

if (ASVAB_Score < 0)
	then ASVAB_Missing = TRUE;
	else ASVAB_Missing = FALSE;

AdjustAFQT = 0;
if (ASVAB_Missing = FALSE)
	then AdjustAFQT = Sec2_Score + Sec3_Score + Sec4_Score + (Sec5_Score / 2);

%AdjAFQT (AdjustAFQT, Age1979, AdjustAFQT);   /* Do the age adjustment here */

/* Handle geographic variables here */
pcnt_black    = R0219010;  /* PRCT POP BLACK-70 CCDB 77 CNTY 79 */
pcnt_hispanic = R0219011;  /* PRCT POP HISPANIC-70 CCDB 72 CNTY 79 */
unemp_rate    = R0219144;  /* 79 CONT UNEMP RATE LAB MARK CUR RES */
median_inc    = R0219103;  /* MED FAM INC($)-69 CCDB 77 SMSA 79 */
if (R0215100 = 1) /* RS CURRENT RESIDENCE URBAN/RURAL 79 */
	then urban = TRUE;
	else urban = FALSE;
if (R0215200 = 1) /* RS CURRENT RESIDENCE IN SMSA 79 */
	then smsa = TRUE;
	else smsa = FALSE;

if (R0216400 = 1) /* REGION OF CURRENT RESIDENCE 79 */
	then northeast = TRUE;
	else northeast = FALSE;
if (R0216400 = 2) /* REGION OF CURRENT RESIDENCE 79 */
	then midwest = TRUE;
	else midwest = FALSE;
if (R0216400 = 3) /* REGION OF CURRENT RESIDENCE 79 */
	then south = TRUE;
	else south = FALSE;
if (R0216400 = 4) /* REGION OF CURRENT RESIDENCE 79 */
	then west = TRUE;
	else west = FALSE;

/* SMSA OF RESIDENCE 79 */
if (R0219003 in (520, /* Atlanta 2.233 mill. */
	1120,  /* Boston 3.149 mill */
    1600, /* 7,246 Chicago */
	1680, /* Cleveland 2,278 */
	1920, /* Dallas 2055 */
	2160, /* Detroit 4,388 */
	3360, /* Houston 2,753 */
	4480, /* LA 7,477 */
	5120, /* Minneapolis-St Paul 2,200 */
	5380, /* Nassau-suffolk 2.6 */
	5600, /* NYC 8.2 */
	5640, /* Newark 2.0 */
	6160, /* Philadelphia 4.8 */
	6280, /* Pittsburgh 2.6 */
	7040, /* St. Louis 2.4 */
	7320, /* San Diego 1.8 */
	7360, /* San. Fran. */
	720,  /* Baltimore */
	8840  /* Washington DC */
)) 
	then MajorMetArea = TRUE;
	else MajorMetArea = FALSE;

/* Handle other variables */

/* CPI (1967=100) values are as follows.  The CPI removes the effects of inflation from pay
	1990	384.4			1991	399.9			1992	411.5
	1993	423.1			1994	433.8 			1995	446.1
	1996	459.1			1997	469.3			1998	475.6
	This program uses 1991 as the base year.
*/

Pay1990     = R3127800 / (384.4 / 399.9); /* HRP CURRENT/M-RCNT JOB 90 */
Marital1990 = R3401300; /* MARITAL STATUS (COLLAPSED) 90 */
HGC1990     = R3401501; /* HIGHEST GRADE COMPLTD (REV) 90 */
Age1990     = R3401700; /* AGE OF R @ INT DATE 90 */
if (Marital1990 = 2)    /* Is R Married? */
	then Marry1990 = TRUE;
	else Marry1990 = FALSE;

Pay1991     = R3523500 / (399.9 / 399.9); /* HRP CURRENT/M-RCNT JOB 91 */
Marital1991 = R3656700; /* MARITAL STATUS (COLLAPSED) 91 */
HGC1991     = R3656901; /* HIGHEST GRADE COMPLTD (REV) 91 */
Age1991     = R3657100; /* AGE OF R @ INT DATE 91 */
if (Marital1991 = 2)    /* Is R Married? */
	then Marry1991 = TRUE;
	else Marry1991 = FALSE;

Pay1992     = R3728500 / (411.5 / 399.9); /* HRP CURRENT/M-RCNT JOB 92 */
Marital1992 = R4007200; /* MARITAL STATUS (COLLAPSED) 92 */
HGC1992     = R4007401; /* HIGHEST GRADE COMPLTD (REV) 92 */
Age1992     = R4007600; /* AGE OF R @ INT DATE 92 */
if (Marital1992 = 2)    /* Is R Married? */
	then Marry1992 = TRUE;
	else Marry1992 = FALSE;

Pay1993     = R4416800 / (423.1 / 399.9); /* HRLY RATE OF PAY CPS JOB 93 */
Marital1993 = R4418300; /* MARITAL STATUS (COLLAPSED) 93 */
HGC1993     = R4418501; /* HIGHEST GRADE COMPLTD (REV) 93 */
Age1993     = R4418700; /* AGE AT INTERVIEW DATE 93 */
if (Marital1993 = 2)    /* Is R Married? */
	then Marry1993 = TRUE;
	else Marry1993 = FALSE;

PAY1994     = R5079800 / (433.8 / 399.9); /* HRLY RATE OF PAY CPS JOB 94 */
Marital1994 = R5081300; /* MARITAL STATUS (COLLAPSED) 94 */
Age1994     = R5081700; /* AGE AT INTERVIEW DATE 94 */
HGC1994     = R5103900; /* HIGHEST GRADE COMPLTD (REV) 94 */
if (Marital1994 = 2)    /* Is R Married? */
	then Marry1994 = TRUE;
	else Marry1994 = FALSE;

Marital1996 = R5166600 / (459.1 / 399.9); /* MARITAL STATUS (COLLAPSED) 96 */
HGC1996     = R5166901; /* HIGHEST GRADE COMPLTD (REV) 96 */
Age1996     = R5167000; /* AGE AT INTERVIEW DATE 96 */
if (Marital1996 = 2)    /* Is R Married? */
	then Marry1996 = TRUE;
	else Marry1996 = FALSE;

Pay1998     = R6478000 / (475.6 / 399.9); /* HRLY RATE OF PAY JOB# 1 1998 */
Marital1998 = R6479200; /* MARITAL STATUS (COLLAPSED) 1998 */
HGC1998     = R6479600; /* HIGHEST GRADE COMPLTD (REV) 1998 */
Age1998     = R6479800; /* AGE AT INTERVIEW DATE 1998 */
if (Marital1998 = 2)    /* Is R Married? */
	then Marry1998 = TRUE;
	else Marry1998 = FALSE;

/* Eliminate top and bottom 1% of pay outliers.  About 100 obs. are lost. */
Array Pay    {1990:1998} Pay1990-Pay1998;
Do i = 1990 to 1998;
   if (Pay {i} > 8000) then Pay {i] = .;
   if (Pay {i} < -5)   then Pay {i] = .;
end;

proc means;
run;

/*************************************/
/*     Step 3:  Stack All Variables. */
/*************************************/

data;
set RawData;   /* Read in the sorted data */

Array Pay    {1990:1998} Pay1990-Pay1998;
Array Ln_Pay {1990:1998} Ln_Pay1990-Ln_Pay1998;
Array Married{1990:1998} Marry1990-Marry1998;
Array HGC    {1990:1998} HGC1990-HGC1998;
Array Age    {1990:1998} Age1990-Age1998;

Do i = 1990 to 1998;
   if (Pay {i} > 0) and (HGC {i} >= 0) then do;
  	  Ln_Pay {i} = Log (Pay {i});
      file 'C:\Documents and Settings\All Users\Desktop\ClusteringandWeighting\Wage&GeoData.dbs';
     	put 
		ID       	5.
 		Ln_Pay {i}  6.2
		Black       2.
		Hispanic    2.
		AdjustAFQT  3.
		ASVAB_Missing 2.
    	Married {i} 2.
		HGC {i}     3.
		Age {i}     3.
		pcnt_black     	3.
		pcnt_hispanic	3.
		unemp_rate		3.
		median_inc		5.
		urban			2.
		smsa			2.
		northeast		2.
		midwest			2.
		south			2.
		west			2.
		MajorMetArea	2.
    	;
  	end;
end;

proc means;
run;

/*******************************************/
/*     Step 4:  Read in Stacked Variables. */
/*******************************************/

data;
infile 'C:\Documents and Settings\All Users\Desktop\ClusteringandWeighting\Wage&GeoData.dbs';
input 
		ID       	5.
 		Ln_Pay      6.2
		Black       2.
		Hispanic    2.
		AdjustAFQT  3.
		ASVAB_Missing 2.
    	Married     2.
		HGC         3.
		Age         3.
		pcnt_black     	3.
		pcnt_hispanic	3.
		unemp_rate		3.
		median_inc		5.
		urban			2.
		smsa			2.
		northeast		2.
		midwest			2.
		south			2.
		west			2.
		MajorMetArea	2.
;

if (pcnt_black > 0)
	then pcnt_black = pcnt_black / 100;
	else pcnt_black = .;
if (pcnt_hispanic > 0)
	then pcnt_hispanic = pcnt_hispanic / 100;
	else pcnt_hispanic = .;
if (unemp_rate > 0)
	then unemp_rate = unemp_rate / 100;
	else unemp_rate = .;
if (median_inc < 0)
	then median_inc = .;

/*********************************************************************************/
/*     Step 5:  Do OLS Uncorrected Regression and then add geographic variables. */
/*********************************************************************************/

PROC REG;
MODEL Ln_Pay = Black Hispanic Age HGC AdjustAFQT Married;

PROC REG;
MODEL Ln_Pay = Black Hispanic Age HGC AdjustAFQT Married pcnt_black pcnt_hispanic median_inc northeast south west MajorMetArea;

run;
