options pagesize=59 linesize=120 nocenter mlogic mprint;
libname lib       'C:/childlifecycle';

data one;set lib.birth;
/* childid momid male black white hispanic ppregBmi smoke bWgt lGest year yob
birthOrd firstTri */

if bWgt<88 then lowBwgt=1;else if bWgt>=88 then lowBwgt=0;

proc means;

proc reg data=one;
    model bWgt = black hispanic male birthOrd firstTri smoke ppregBmi ;
    Title 'Birth weight regression'; 
    
proc logistic data=one;
    model lowBwgt (event='1') = black hispanic male birthOrd firstTri smoke ppregBmi;
    Title 'Low birth weight logistic regression'; 
    

proc mixed data=one; 
      class momid; 
      model  bWgt = black hispanic male birthOrd firstTri smoke ppregBmi / solution ;  
      random int  / type=un sub=momid;    
    Title 'Random effects Birth weight regression'; 
run;
      
