program birhist2
IMPLICIT NONE
! Date: July 16, 2007 
! Program reads nlsy_birth.dat and nlsy_marriage.dat and codes the marital
! status of each birth

   Integer , parameter :: MAXOBS = 12686
   Integer , parameter :: MAXBIRTH = 11
   Integer , parameter :: MAXMAR   =  3
   Integer , parameter :: MaxDIV   =  2
   Integer , parameter :: MAX_HIST = 700 
   
   Type marr
      Integer :: bdate,edate,mflag,dflag
   end type marr 

   Type mhis
      Integer :: ms, mflag, dflag
   end type mhis

   Integer , dimension(MAXBIRTH)  :: bir,bflag,gender
   Type(marr) , dimension(MAXMAR) :: mar
   Type(mhis) , dimension(MAX_HIST) :: mhist

   Integer :: j,nrec,totrec,caseid,marnum,nunit,bunit,munit
   Integer :: rnd,ceb,marstate,bf,mf,df,bsex,bdate,edate,tf,ecnt

   bunit=3
   open(unit=bunit,file="nlsy_birth.dat",STATUS="OLD")
   munit=4
   open(unit=munit,file="nlsy_marriage.dat",STATUS="OLD")
   open(unit=17,file="nlsy_ms_birth.dat",STATUS="REPLACE")


   totrec   = 0
! write case to birth file
   nrec = 0
   do
      read(unit=bunit,FMT='(I5,2I3,1X,11(I4,2I2))') &
            caseid,rnd,ceb,(bir(j),gender(j),bflag(j),j=1,11)
      read(unit=munit,FMT='(I5,I3,I2,1X,3(2I5,2I4))') caseid,rnd,marnum,&
            (mar(j)%bdate,mar(j)%edate,mar(j)%mflag,mar(j)%dflag,j=1,3)
      nrec = nrec + 1!
!      print *,"debug: read case ",nrec," caseid = ",caseid

      ! loop over marriages and assign marital status for each month
      mhist(:)%ms = 0   !single - default
      mhist(:)%mflag = 0 !correct - default
      mhist(:)%dflag = 0 !correct - default

      do j=1,marnum
         bdate = mar(j)%bdate
         edate = mar(j)%edate
         if (edate == -99) edate = 660 !never ends
         tf    = mar(j)%mflag
         if (bdate < 1 .or. bdate > MAX_HIST) then
!            print *,"Error: Marriage record out of bounds."
!            print *,"  caseid  = ",caseid," marriage number= ",marnum
!            print *,"  bdate   = ",bdate," edate = ",edate
            bdate = 120 !Jan 1960
!            tf    = -1 
         end if
         if (edate < 1 .or. edate > MAX_HIST) then
!            print *,"Error: Marriage record out of bounds."
!            print *,"  caseid  = ",caseid," marriage number= ",marnum
!            print *,"  bdate   = ",bdate," edate = ",edate
            edate = 660 !Jan 2005
!            tf    = -1
         end if
         mhist(bdate:edate)%ms = 1 !married
         mhist(bdate:edate)%mflag = tf 
      end do !marriage

      do j=1,marnum-1
         bdate = mar(j)%edate
         edate = mar(j+1)%bdate-1
         tf    = mar(j)%dflag

         if (bdate < 1 .or. bdate > MAX_HIST) then
!            print *,"Error: Divorce record out of bounds."
!            print *,"  caseid  = ",caseid," marriage number= ",marnum
!            print *,"  bdate   = ",bdate," edate = ",edate
            bdate = 120 !Jan 1960
!            tf    = -1 
         end if
         if (edate < 1 .or. edate > MAX_HIST) then
!            print *,"Error: Divorce record out of bounds."
!            print *,"  caseid  = ",caseid," marriage number= ",marnum
!            print *,"  bdate   = ",bdate," edate = ",edate
            edate = 660 !Jan 2005
!            tf    = -1
         end if
         mhist(bdate:edate)%ms = 2 !divorced
         mhist(bdate:edate)%dflag = tf
      end do

      !loop over births and write out "long file"

      do j=1,ceb
         if (bir(j) < 0 .or. bir(j) > MAX_HIST) then
            print *,"Warning: Birth date out of range."
            print *,"   date: ",bir(j)
            print *," "
            ecnt = ecnt + 1
         else 
            marstate = mhist(bir(j))%ms
            bf    = bflag(j)
            mf    = mhist(bir(j))%mflag
            df    = mhist(bir(j))%dflag
            bsex  = gender(j)

            write(unit=17,fmt='(I5,I3,I2,I5,4I3)') &
               caseid,j,bsex,bir(j),marstate,bf,mf,df 
            totrec = totrec + 1
         end if
     end do !ceb

      if (nrec == 12507) exit !do
   end do 

   print *," "
   print *,"Total birth records written: ",totrec
   print *," Number of births with unuseable dates: ",ecnt
   print *," "
   close(unit=3)
   close(unit=4)
   close(unit=17)
end program birhist2
