options pagesize=59 linesize=80 nocenter;
data;
infile 'last-interview-469cbcf01dbc8.dat' lrecl=67 missover DSD DLM=' ';
input
  R0000100
  R0406310
  R0618810
  R0898510
  R1144710
  R1519910
  R1890300
  R2257400
  R2444600
  R2870100
  R3073900
  R3400500
  R3655900
  R4006400
  R4417500
  R5080500
  R5165800
  R6478500
  R7006300
  R7703500
  R8495900
  ;
array chrrlst 
  R0000100 -- R8495900
  ;
do over chrrlst;
  if chrrlst = -5 then chrrlst = .A;
  if chrrlst = -4 then chrrlst = .B;
  if chrrlst = -3 then chrrlst = .C;
  if chrrlst = -2 then chrrlst = .D;
  if chrrlst = -1 then chrrlst = .E;
  end;
label R0000100 = "ID# (1-12686) 79";
label R0406310 = "REASON FOR NONINT 80";
label R0618810 = "REASON FOR NONINT 81";
label R0898510 = "REASON FOR NONINT 82";
label R1144710 = "REASON FOR NONINT 83";
label R1519910 = "REASON FOR NONINT 84";
label R1890300 = "REASON FOR NONINT 85";
label R2257400 = "REASON FOR NONINT 86";
label R2444600 = "REASON FOR NONINT 87";
label R2870100 = "REASON FOR NONINT 88";
label R3073900 = "REASON FOR NONINT 89";
label R3400500 = "REASON FOR NONINT 90";
label R3655900 = "REASON FOR NONINT 91";
label R4006400 = "REASON FOR NONINT 92";
label R4417500 = "REASONS FOR NON-INT 93";
label R5080500 = "REASONS FOR NON-INT 94";
label R5165800 = "REASONS FOR NON-INT 96";
label R6478500 = "REASONS FOR NON-INT 1998";
label R7006300 = "REASONS FOR NON-INT 2000";
label R7703500 = "REASONS FOR NON-INT 2002";
label R8495900 = "REASONS FOR NON-INT 2004";
proc format;
value vx1f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT AND YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT AND YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
    ;
value vx2f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT AND YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT AND YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
    ;
value vx3f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
    ;
value vx4f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
    ;
value vx5f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
    ;
value vx6f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
    ;
value vx7f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
    ;
value vx8f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
    ;
value vx9f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
    ;
value vx10f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
    ;
value vx11f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
    ;
value vx12f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
  69='SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
    ;
value vx13f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
  69='SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
    ;
value vx14f
  60='PARENT REFUSAL/BREAKOFF'
  61='YOUTH REFUSAL/BREAKOFF'
  62='PARENT & YOUTH REFUSAL/BREAKOFF'
  63='UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='UNABLE TO LOCATE YOUTH'
  65='DECEASED'
  66='OTHER'
  67='DO NOT REFIELD (VERY DIFFICULT CASES)'
  68='MILITARY SAMPLE DROPPED'
  69='SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
    ;
value vx15f
  60='60: 60  PARENT REFUSAL/BREAKOFF'
  61='61: 61  YOUTH REFUSAL/BREAKOFF'
  62='62: 62  PARENT & YOUTH REFUSAL/BREAKOFF'
  63='63: 63  UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='64: 64  UNABLE TO LOCATE YOUTH'
  65='65: 65  DECEASED'
  66='66: 66  OTHER'
  67='67: 67  DO NOT REFIELD (VERY DIFFICULT CASE)'
  68='68: 68  MILITARY SAMPLE DROPPED'
  69='69: 69  SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='70: 70  SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
    ;
value vx16f
  60='60: PARENT REFUSAL/BREAKOFF'
  61='61: YOUTH REFUSAL/BREAKOFF'
  62='62: PARENT & YOUTH REFUSAL/BREAKOFF'
  63='63: UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='64: UNABLE TO LOCATE YOUTH'
  65='65: DECEASED'
  66='66: OTHER'
  67='67: DO NOT REFIELD (VERY DIFFICULT CASE)'
  68='68: MILITARY SAMPLE DROPPED'
  69='69: SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='70: SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
    ;
value vx17f
  60='60: 60  PARENT REFUSAL/BREAKOFF'
  61='61: 61  YOUTH REFUSAL/BREAKOFF'
  62='62: 62  PARENT & YOUTH REFUSAL/BREAKOFF'
  63='63: 63  UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='64: 64  UNABLE TO LOCATE YOUTH'
  65='65: 65  DECEASED'
  66='66: 66  OTHER'
  67='67: 67  DO NOT REFIELD (VERY DIFFICULT CASE)'
  68='68: 68  MILITARY SAMPLE DROPPED'
  69='69: 69  SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='70: 70  SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
    ;
value vx18f
  60='60: PARENT REFUSAL/BREAKOFF'
  61='61: YOUTH REFUSAL/BREAKOFF'
  62='62: PARENT & YOUTH REFUSAL/BREAKOFF'
  63='63: UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='64: UNABLE TO LOCATE YOUTH'
  65='65: DECEASED'
  66='66: OTHER'
  67='67: DO NOT REFIELD (VERY DIFFICULT CASE)'
  68='68: MILITARY SAMPLE DROPPED'
  69='69: SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='70: SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
  71='71: YOUTH REFUSAL - VERY DIFFICULT CASE'
    ;
value vx19f
  60='60: 60  PARENT REFUSAL/BREAKOFF'
  61='61: 61  YOUTH REFUSAL/BREAKOFF'
  62='62: 62  PARENT & YOUTH REFUSAL/BREAKOFF'
  63='63: 63  UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='64: 64  UNABLE TO LOCATE YOUTH'
  65='65: 65  DECEASED'
  66='66: 66  OTHER'
  67='67: 67  DO NOT REFIELD (VERY DIFFICULT CASE)'
  68='68: 68  MILITARY SAMPLE DROPPED'
  69='69: 69  SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='70: 70  SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
  71='71: 71  YOUTH REFUSAL - VERY DIFFICULT CASE'
  72='72: 72  NOT FIELDED IN CURRENT SURVEY YEAR - VERY DIFFICULT CASE'
    ;
value vx20f
  60='60: 60  PARENT REFUSAL/BREAKOFF'
  61='61: 61  YOUTH REFUSAL/BREAKOFF'
  62='62: 62  PARENT & YOUTH REFUSAL/BREAKOFF'
  63='63: 63  UNABLE TO LOCATE FAMILY UNIT & YOUTH'
  64='64: 64  UNABLE TO LOCATE YOUTH'
  65='65: 65  DECEASED'
  66='66: 66  OTHER'
  67='67: 67  DO NOT REFIELD (VERY DIFFICULT CASE)'
  68='68: 68  MILITARY SAMPLE DROPPED'
  69='69: 69  SUPPLEMENTAL MALE POOR WHITE SAMPLE DROPPED'
  70='70: 70  SUPPLEMENTAL FEMALE POOR WHITE SAMPLE DROPPED'
  71='71: 71  YOUTH REFUSAL - VERY DIFFICULT CASE'
  72='72: 72  NOT FIELDED IN CURRENT SURVEY YEAR - VERY DIFFICULT CASE'
  73='73: 73  NOT INTERVIEWED - INCARCERATED'
  74='74: 74  NOT INTERVIEWED - IN MILITARY'
    ;
/*
  format R0406310 vx1f.;
  format R0618810 vx2f.;
  format R0898510 vx3f.;
  format R1144710 vx4f.;
  format R1519910 vx5f.;
  format R1890300 vx6f.;
  format R2257400 vx7f.;
  format R2444600 vx8f.;
  format R2870100 vx9f.;
  format R3073900 vx10f.;
  format R3400500 vx11f.;
  format R3655900 vx12f.;
  format R4006400 vx13f.;
  format R4417500 vx14f.;
  format R5080500 vx15f.;
  format R5165800 vx16f.;
  format R6478500 vx17f.;
  format R7006300 vx18f.;
  format R7703500 vx19f.;
  format R8495900 vx20f.;
*/
/* *start* Crosswalk for Reference number & Question name
    R0000100    CASEID
    R0406310    *Created
    R0618810    *Created
    R0898510    *Created
    R1144710    *Created
    R1519910    *Created
    R1890300    *Created
    R2257400    *Created
    R2444600    *Created
    R2870100    *Created
    R3073900    *Created
    R3400500    *Created
    R3655900    *Created
    R4006400    *Created
    R4417500    RNI
    R5080500    RNI
    R5165800    RNI
    R6478500    RNI
    R7006300    RNI
    R7703500    RNI
    R8495900    RNI
      * *finish* */
proc means n mean min max;
run;
