options pagesize=59 linesize=80 nocenter;
data;
infile 'missingdataeg04-469a68600c417.dat' lrecl=39 missover DSD DLM=' ';
input
  C0000100
  C0000200
  C0011202
  C0011203
  C0011210
  C0011211
  Y0652900
  Y1464100
  Y1464200
  Y1464300
  ;
array chrrlst 
  C0000100 -- Y1464300
  ;
do over chrrlst;
  if chrrlst = -5 then chrrlst = .A;
  if chrrlst = -4 then chrrlst = .B;
  if chrrlst = -3 then chrrlst = .C;
  if chrrlst = -2 then chrrlst = .D;
  if chrrlst = -1 then chrrlst = .E;
  if chrrlst = -7 then chrrlst = .F;
  end;
label C0000100 = "ID CODE OF CHILD";
label C0000200 = "ID CODE OF MOTHER OF CHILD";
label C0011202 = "IS CHILD ELIGIBLE FOR YA INTERVIEW? 96";
label C0011203 = "WAS CHILD INTERVIEWED AS YOUNG ADULT? 96";
label C0011210 = "IS CHILD ELIGIBLE FOR YA INTERVIEW? 2004";
label C0011211 = "WAS CHILD INTERVWD AS YOUNG ADULT? 2004";
label Y0652900 = "AGE AT FIRST DRINK OF BEER/WINE/LIQU  96";
label Y1464100 = "CHECK: R REPTD DATING IN PREV SUR 2004";
label Y1464200 = "HAS R STARTED DATING? 2004";
label Y1464300 = "AGE IN YEARS WHEN R STARTED DATING 2004";
proc format;
value vx0f
  1-9999999='1 TO 9999999: See Min & Max values below for range as of this release'
    ;
value vx1f
  1-12686='1 TO 12686: NLSY79 Public ID'
    ;
value vx2f
  1='Yes'
  0='No'
    ;
value vx3f
  1='Yes'
  0='No'
    ;
value vx4f
  0='CHILD NOT ELIGIBLE FOR YOUNG ADULT INTERVIEW'
  1='CHILD ELIGIBLE FOR YOUNG ADULT INTERVIEW'
  2='CHILD ELIGIBLE FOR YA, BUT NOT INTERVIEWED; IN MILITARY'
  3='CHILD ELIGIBLE FOR YA, BUT NOT INTERVIEWED; IN PRISON'
    ;
value vx5f
  1='Yes'
  0='No'
    ;
value vx6f
  0-9='0 TO 9: LESS THAN 10 YEARS OLD'
  18='18: 18 YEARS OLD'
  19='19: 19 YEARS OLD'
  20='20: 20 YEARS OLD'
  21='21: 21 YEARS OLD'
  22='22: 22 YEARS OLD'
  23='23: 23 YEARS OLD'
  24='24: 24 YEARS OLD'
  25='25: 25 YEARS OLD'
  26-95='26 TO 95: MORE THAN 25 YEARS OLD'
  10='10: 10 YEARS OLD'
  11='11: 11 YEARS OLD'
  12='12: 12 YEARS OLD'
  13='13: 13 YEARS OLD'
  14='14: 14 YEARS OLD'
  15='15: 15 YEARS OLD'
  16='16: 16 YEARS OLD'
  17='17: 17 YEARS OLD'
    ;
value vx7f
  1='1: CONDITION APPLIES'
  0='0: CONDITION DOES NOT APPLY'
    ;
value vx8f
  1='SELECT TO ENTER AGE'
  0='Never started'
  99='Volunteered same-sex dating'
    ;
value vx9f
  0-9='0 TO 9'
  18='18'
  19='19'
  20='20'
  21='21'
  22='22'
  23='23'
  24='24'
  25='25'
  26-99='26 TO 99: 26+'
  10='10'
  11='11'
  12='12'
  13='13'
  14='14'
  15='15'
  16='16'
  17='17'
    ;
/*
  format C0000100 vx0f.;
  format C0000200 vx1f.;
  format C0011202 vx2f.;
  format C0011203 vx3f.;
  format C0011210 vx4f.;
  format C0011211 vx5f.;
  format Y0652900 vx6f.;
  format Y1464100 vx7f.;
  format Y1464200 vx8f.;
  format Y1464300 vx9f.;
*/
/* *start* Crosswalk for Reference number & Question name
    C0000100    CPUBID
    C0000200    MPUBID
    C0011202    YASAMP1996
    C0011203    YAINTV1996
    C0011210    YASAMP2004
    C0011211    YAINTV2004
    Y0652900    YA960151
    Y1464100    Q3-0E
    Y1464200    Q3-1
    Y1464300    Q3-1A
      * *finish* */
proc means n mean min max;
run;
